// Задача "Циклические палиндромы"
// XVI командный чемпионат школьников Санкт-Петербурга по программированию
// Автор задачи: Сергей Мельников, melnikov@rain.ifmo.ru
// Автор решения: Сергей Поромов, poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class palin_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new palin_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "palin";
	
	boolean isPalin(String s) {
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) != s.charAt(s.length() - i - 1)) {
				return false;
			}
		}
		return true;
	}

	public void solve() throws IOException {
		String s = nextToken();
		int n = s.length();
		for (int i = 0; i < n; i++) {
			if (isPalin(s.substring(i, n) + s.substring(0, i))) {
				out.println("yes");
				return;
			}
		}
		out.println("no");
	}
}
